import { world, system, EquipmentSlot, EntityEquippableComponent } from "@minecraft/server";
const placedLightBlocks = new Map();

system.runInterval(() => {
    for (const [key, blockInfo] of placedLightBlocks.entries()) {
        const { dimension, x, y, z } = blockInfo;
        dimension.runCommandAsync(
            `fill ${x} ${y} ${z} ${x} ${y} ${z} air replace light_block_10`
        );
        placedLightBlocks.delete(key);
    }
});
system.runInterval(() => {
    for (const player of world.getPlayers()) {
        const equippableComponent = player.getComponent(
            EntityEquippableComponent.componentId
          );
        const Head = equippableComponent.getEquipment(EquipmentSlot.Head); 
         if (
            (Head?.typeId == ("true:miners_helmet"))
            ) 
            {
            const position = player.location;
            const x = Math.floor(position.x);
            const y = Math.floor(position.y);
            const z = Math.floor(position.z);
            const positionKey = `${x},${y},${z}`;
            if (!placedLightBlocks.has(positionKey)) {
                player.dimension.runCommandAsync(
                    `setblock ${x} ${y} ${z} light_block_10 keep`
                );
                placedLightBlocks.set(positionKey, { dimension: player.dimension, x, y, z });
            }
        }
    }
});
system.runInterval(() => {
    for (const player of world.getPlayers()) {
        const equippableComponent = player.getComponent(
            EntityEquippableComponent.componentId
          );
        const Head = equippableComponent.getEquipment(EquipmentSlot.Head); 
         if (
            (Head?.typeId == ("true:miners_helmet_iron"))
            ) 
            {
            const position = player.location;
            const x = Math.floor(position.x);
            const y = Math.floor(position.y);
            const z = Math.floor(position.z);
            const positionKey = `${x},${y},${z}`;
            if (!placedLightBlocks.has(positionKey)) {
                player.dimension.runCommandAsync(
                    `setblock ${x} ${y} ${z} light_block_10 keep`
                );
                placedLightBlocks.set(positionKey, { dimension: player.dimension, x, y, z });
            }
        }
    }
});
system.runInterval(() => {
    for (const player of world.getPlayers()) {
        const equippableComponent = player.getComponent(
            EntityEquippableComponent.componentId
          );
        const Head = equippableComponent.getEquipment(EquipmentSlot.Head); 
         if (
            (Head?.typeId == ("true:miners_helmet_diamond"))
            ) 
            {
            const position = player.location;
            const x = Math.floor(position.x);
            const y = Math.floor(position.y);
            const z = Math.floor(position.z);
            const positionKey = `${x},${y},${z}`;
            if (!placedLightBlocks.has(positionKey)) {
                player.dimension.runCommandAsync(
                    `setblock ${x} ${y} ${z} light_block_10 keep`
                );
                placedLightBlocks.set(positionKey, { dimension: player.dimension, x, y, z });
            }
        }
    }
});
system.runInterval(() => {
    for (const player of world.getPlayers()) {
        const equippableComponent = player.getComponent(
            EntityEquippableComponent.componentId
          );
        const Head = equippableComponent.getEquipment(EquipmentSlot.Head); 
         if (
            (Head?.typeId == ("true:miners_helmet_netherite"))
            ) 
            {
            const position = player.location;
            const x = Math.floor(position.x);
            const y = Math.floor(position.y);
            const z = Math.floor(position.z);
            const positionKey = `${x},${y},${z}`;
            if (!placedLightBlocks.has(positionKey)) {
                player.dimension.runCommandAsync(
                    `setblock ${x} ${y} ${z} light_block_10 keep`
                );
                placedLightBlocks.set(positionKey, { dimension: player.dimension, x, y, z });
            }
        }
    }
});
